(* Time-stamp: <modified the 25/01/2016 (at 11:17) by Erwan Jahier> *)
open Soc
open Data
open SocExecValue

(* exported *)
let rec (do_step : Soc.tbl -> Soc.t -> SocExecValue.ctx -> SocExecValue.ctx) =
  fun soc_tbl soc ctx ->
    let step = match soc.step with [step] -> step | _ ->  assert false in
    let ctx = SocExec.soc_step step soc_tbl soc ctx in
    ctx

(* exported *)
let rec (do_step_dbg : Soc.tbl -> Soc.t -> Event.ctx -> SocExecValue.ctx ->
         (SocExecValue.ctx -> Event.t) -> Event.t) =
  fun soc_tbl soc ectx ctx cont ->
    (*  XXX un peu exegéré de mettre tout ?*)
(*     let (datal:Data.subst list) = SocExecValue.substs_to_data_subst ctx.s in *)
    let (datal:Data.subst list) = SocExecValue.filter_top_subst ctx.s in
    let (soc_name,_,_) = soc.key in
    let ectx = { 
      ectx with 
        Event.ctx_name = soc_name;
        Event.ctx_depth = ectx.Event.ctx_depth+1;
        Event.ctx_data = datal;
        Event.ctx_inputs  = fst soc.profile;
        Event.ctx_outputs = snd soc.profile;
    } 
    in
    let cont2 ctx =
      let enb = Event.incr_nb () in
      { 
        Event.step = ectx.Event.ctx_step;
        Event.nb = enb;
        Event.depth = ectx.Event.ctx_depth;
        Event.kind = Event.Exit;
        Event.lang = "lustre";
        Event.name = soc_name;
        Event.inputs = ectx.Event.ctx_inputs;
        Event.outputs = ectx.Event.ctx_outputs;
        Event.sinfo = None;
        Event.data = ectx.Event.ctx_data;
        Event.next = (fun () -> Event.set_nb enb; cont ctx);
        Event.terminate = ectx.Event.ctx_terminate;
      } 
    in
    { 
      Event.step = ectx.Event.ctx_step;
      Event.nb = (Event.incr_nb ());
      Event.depth = ectx.Event.ctx_depth;
      Event.kind = Event.Call;
      Event.lang = "lustre";
      Event.name = soc_name;
      Event.inputs = ectx.Event.ctx_inputs;
      Event.outputs = ectx.Event.ctx_outputs;
      Event.sinfo = None;
      Event.data = ectx.Event.ctx_data;
      Event.next = (fun () -> 
        let step = match soc.step with [step] -> step | _ ->  assert false in
        let ctx = SocExec.soc_step step soc_tbl soc ctx in
        cont2 ctx
      );
      Event.terminate = ectx.Event.ctx_terminate;
    }

